<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIGL: src/standard/communication/tiglCommunicationPregelCommunicator.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIGL
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_512e97a87e29490d503e7e4403f25482.html">standard</a></li><li class="navelem"><a class="el" href="dir_8ae10044201bd9cdcbde8114bcd40f55.html">communication</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglCommunicationPregelCommunicator.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglCommunicationPregelCommunicator_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#ifndef TIGLPREGELCOMMUNICATOR_HPP_</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#define TIGLPREGELCOMMUNICATOR_HPP_</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &quot;types.h&quot;</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglCommunicationSysMessage_8hpp.html">tiglCommunicationSysMessage.hpp</a>&quot;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="tiglContainersPregelDataContainer_8hpp.html">tiglContainersPregelDataContainer.hpp</a>&quot;</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#if defined(_MPI)</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &lt;mpi.h&gt;</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#if defined(DEBUG_MPI)</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#define TEST_RCVR       160</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#define MAX_MESSAGE_SIZE    2048</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DATA_CONTAINER_TYPE&gt;</div>
<div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html">   52</a></span>&#160;<span class="keyword">class </span><a class="code" href="classPregelCommunicator.html">PregelCommunicator</a></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;{</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> DATA_CONTAINER_TYPE::MESSAGE_TYPE              MESSAGE_TYPE;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keyword">typedef</span> <a class="code" href="classSysMessage.html">TIGLCommunicationSysMessage</a>                                              <a class="code" href="classSysMessage.html">SYS_MESSAGE_TYPE</a>;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keyword">typedef</span> vector&lt;MESSAGE_TYPE&gt;                                    MESSAGE_BUF_TYPE;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> MESSAGE_BUF_TYPE::iterator                     MESSAGE_BUF_ITERATOR;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keyword">typedef</span> vector&lt;SYS_MESSAGE_TYPE&gt;                                SYS_MESSAGE_BUF_TYPE;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> DATA_CONTAINER_TYPE::ID_TYPE                   ID_TYPE;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> DATA_CONTAINER_TYPE::INDEX_ITERATOR            INDEX_ITERATOR;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keyword">typedef</span> vector&lt;MESSAGE_BUF_TYPE&gt;  *                             MBUF_PTR;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keyword">typedef</span> SYS_MESSAGE_BUF_TYPE *                                  SYS_MBUF_PTR;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="comment">// constructor/destructor</span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <a class="code" href="classPregelCommunicator.html">PregelCommunicator</a>()</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    {</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        reset();</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    }</div>
<div class="line"><a name="l00073"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#ac9fa67b645c820c2f37cea3dcd36fbd7">   73</a></span>&#160;    <a class="code" href="classPregelCommunicator.html#ac9fa67b645c820c2f37cea3dcd36fbd7">PregelCommunicator</a>(DATA_CONTAINER_TYPE * dataPtr, uint32 devices, <span class="keywordtype">int</span> rank = 0)</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    {</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        init(dataPtr, devices, rank);</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        totalNumVertices = 0;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    }</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    ~<a class="code" href="classPregelCommunicator.html">PregelCommunicator</a>(){}</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00083"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#ad0836c0a6713b5084626c053b2609721">   83</a></span>&#160;<span class="comment"></span>    DATA_CONTAINER_TYPE * <a class="code" href="classPregelCommunicator.html#ad0836c0a6713b5084626c053b2609721">dataPtr</a>;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="keywordtype">bool</span> initFlag;</div>
<div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#a1d2f789f3c492ab86520f2f9f05e4f7d">   87</a></span>&#160;    uint32 <a class="code" href="classPregelCommunicator.html#a1d2f789f3c492ab86520f2f9f05e4f7d">numDevices</a>;</div>
<div class="line"><a name="l00090"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#a9342c483ed8bc1478e5991cac92304a0">   90</a></span>&#160;    uint64 <a class="code" href="classPregelCommunicator.html#a9342c483ed8bc1478e5991cac92304a0">totalNumVertices</a>;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;</div>
<div class="line"><a name="l00093"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#ad2369b8d191a328714ce2c0c9372e1b6">   93</a></span>&#160;    uint32 * <a class="code" href="classPregelCommunicator.html#ad2369b8d191a328714ce2c0c9372e1b6">timeCountSS</a>;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div>
<div class="line"><a name="l00096"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#a886da2e5d226022133297f6461033f2a">   96</a></span>&#160;    uint32 <a class="code" href="classPregelCommunicator.html#a886da2e5d226022133297f6461033f2a">rank</a>;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00102"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#ac0c5a6de5c5f1802a46962a2ea7294fc">  102</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classPregelCommunicator.html#ac0c5a6de5c5f1802a46962a2ea7294fc">reset</a>()</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    {</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        dataPtr = 0;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        initFlag = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        totalNumVertices = 0;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    }</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> init(uint32 * timePtr)</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    {</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        timeCountSS = timePtr;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    }</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00122"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#a0c1fec23444ddd131dd6eac0626ada3b">  122</a></span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classPregelCommunicator.html#a0c1fec23444ddd131dd6eac0626ada3b">init</a>(DATA_CONTAINER_TYPE * dPtr, uint32 devices = 1, uint32 devRank = 0)</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    {</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        dataPtr = dPtr;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        initFlag = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        numDevices = devices;</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        rank = devRank;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    }</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00134"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#a0b8291a5b8a01bed346f27d6eb2b519e">  134</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classPregelCommunicator.html#a0b8291a5b8a01bed346f27d6eb2b519e">setNumVertices</a>(uint64 numVertices)</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    {</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        totalNumVertices = numVertices;</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    }</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00140"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#aac3d9db0bfd173f6c9d24d06d8ff0a56">  140</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classPregelCommunicator.html#aac3d9db0bfd173f6c9d24d06d8ff0a56">isMultipleDevices</a>(){<span class="keywordflow">return</span> (numDevices &gt; 1);}</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00145"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#acf608880f1a6eec80af5fe638422d94b">  145</a></span>&#160;<span class="comment"></span>    <span class="keywordtype">void</span> <a class="code" href="classPregelCommunicator.html#acf608880f1a6eec80af5fe638422d94b">sendAllMessages</a>(map&lt;ID_TYPE, MESSAGE_BUF_TYPE&gt; * messagePtr)</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    {</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        sendSysMessages();</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        sendDataMessages(messagePtr);</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;    }</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00153"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#a8e99d93e817dc4cc4a7d97d34a941d41">  153</a></span>&#160;<span class="comment"></span>    <span class="keywordtype">void</span> <a class="code" href="classPregelCommunicator.html#a8e99d93e817dc4cc4a7d97d34a941d41">sendSysMessages</a>()</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    {</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        byte outBuf[MAX_MESSAGE_SIZE];</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        SYS_MBUF_PTR outSysMessagesPtr = dataPtr-&gt;getOutSysMessageBuf();</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        <span class="keywordflow">for</span>(<span class="keyword">typename</span> vector&lt;SYS_MESSAGE_TYPE&gt;::iterator it= outSysMessagesPtr-&gt;begin();</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;                it != outSysMessagesPtr-&gt;end(); ++it)</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        {<span class="comment">// outer loop over all destinations</span></div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;            <span class="comment">// constructing the message body</span></div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;            uint32 messageSize = it-&gt;pack(outBuf);<span class="comment">//it-&gt;toBytes(outBuf);//sysMessage2Bytes(*it, outBuf);</span></div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;            SYS_MESSAGE_CODE code = it-&gt;getMessageCode();</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;            <span class="keywordflow">if</span>(code == AGGREGATE_INFO || code == DEV_IDLE || code == HALT)</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;            { <span class="comment">// broadcast message</span></div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;                <span class="keywordflow">for</span>(uint32 dev = 0 ; dev &lt; numDevices; dev++)</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;                    <span class="keywordflow">if</span>(dev != rank)</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;                        TIGLCommunicationSendMPICommand(outBuf, messageSize, dev, MPI_SYSTEM_MESSAGE_TAG);</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;            }</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;            <span class="keywordflow">else</span></div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;            {</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;                uint32 deviceAddress = it-&gt;getDst();</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;                TIGLCommunicationSendMPICommand(outBuf, messageSize, deviceAddress, MPI_SYSTEM_MESSAGE_TAG);</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;            }</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        }</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    }</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00184"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#a0b2ec835552c9c7c11914f42f928af0b">  184</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classPregelCommunicator.html#a0b2ec835552c9c7c11914f42f928af0b">sendDataMessages</a>(map&lt;ID_TYPE, MESSAGE_BUF_TYPE&gt; * messagePtr)</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    {</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        byte outBuf[MAX_MESSAGE_SIZE];</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;        <span class="keywordflow">if</span>(messagePtr-&gt;empty())</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;            <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        <span class="keywordflow">for</span>(uint32 dev = 0 ; dev &lt; numDevices; dev ++)</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;        { <span class="comment">// loop for accumulating and sending messages for each device</span></div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;            <span class="keywordflow">if</span>(dev == rank)</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;                <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;            uint32 accMessageSize = 0;</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;            <span class="keywordflow">for</span>(<span class="keyword">typename</span> map&lt;ID_TYPE, MESSAGE_BUF_TYPE&gt;::iterator it= messagePtr-&gt;begin();</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;                    it != messagePtr-&gt;end(); ++it)</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;            {<span class="comment">// outer loop over all destinations</span></div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;                ID_TYPE rcvr = it-&gt;first;</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;                <span class="keywordflow">if</span>(TIGLCommunicationFindDevice(rcvr) != dev)<span class="comment">//uint32 deviceId = TIGLCommunicationFindDevice(rcvr);</span></div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;                    <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;                <span class="comment">// constructing the message body</span></div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;                uint32 messageSize = messages2Bytes(&amp;(it-&gt;second), outBuf+accMessageSize);</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;                accMessageSize += messageSize;</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;<span class="preprocessor">#if defined(DEBUG_MPI)</span></div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;                <span class="keywordflow">if</span>(rcvr == TEST_RCVR)<span class="comment">//if(deviceId == 2)</span></div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;                    cout &lt;&lt; <span class="stringliteral">&quot;dev&quot;</span> &lt;&lt; rank &lt;&lt;<span class="stringliteral">&quot; (&quot;</span>&lt;&lt; (it-&gt;second).size() &lt;&lt;  <span class="stringliteral">&quot;) -&gt; dev&quot;</span> &lt;&lt; dev &lt;&lt; <span class="stringliteral">&quot;(&quot;</span>&lt;&lt; rcvr &lt;&lt; <span class="stringliteral">&quot;):  &quot;</span> &lt;&lt; (it-&gt;second).begin()-&gt;getContent() &lt;&lt; endl;</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;                <span class="comment">//TIGLCommunicationSendMPICommand(outBuf, messageSize, deviceId);</span></div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;                <span class="keywordflow">if</span>(accMessageSize &gt; MAX_MESSAGE_SIZE - 2*messageSize)</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;                {</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;                    TIGLCommunicationSendMPICommand(outBuf, accMessageSize, dev, MPI_DATA_MESSAGE_TAG);</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;                    accMessageSize = 0;</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;                }</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;            }</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;            <span class="keywordflow">if</span>(accMessageSize)</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;                TIGLCommunicationSendMPICommand(outBuf, accMessageSize, dev, MPI_DATA_MESSAGE_TAG);</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        }</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    }</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00226"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#aa93cebf937b0f2bea1873a6aa9f9f132">  226</a></span>&#160;<span class="comment"></span>    <span class="keywordtype">void</span> <a class="code" href="classPregelCommunicator.html#aa93cebf937b0f2bea1873a6aa9f9f132">TIGLCommunicationSendMPICommand</a>(byte * txBuf, uint32 bufSize, int32 dst)</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;    {</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;<span class="preprocessor">#if defined(_MPI)</span></div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;        <span class="comment">// rank: my process id</span></div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;        <span class="comment">// dst: destination rank id</span></div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;        MPI_Send(txBuf, bufSize, MPI_CHAR, dst, rank, MPI_COMM_WORLD);</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;    }</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00242"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#a87e606cfb6aa33ece2ab1ac00d41be24">  242</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classPregelCommunicator.html#a87e606cfb6aa33ece2ab1ac00d41be24">TIGLCommunicationSendMPICommand</a>(byte * txBuf, uint32 bufSize, int32 dst, <span class="keywordtype">int</span> tag)</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;    {</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;<span class="preprocessor">#if defined(_MPI)</span></div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        MPI_Send(txBuf, bufSize, MPI_CHAR, dst, tag, MPI_COMM_WORLD);</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    }</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00255"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#a65d86ed247f64d459e354692048afaa0">  255</a></span>&#160;<span class="comment"></span>    <span class="keywordtype">bool</span> <a class="code" href="classPregelCommunicator.html#a65d86ed247f64d459e354692048afaa0">instRecvMessages</a>()</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;    {</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        byte rxBuf[MAX_MESSAGE_SIZE];</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        MESSAGE_BUF_TYPE messageBuf;</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;        SYS_MBUF_PTR inSysMessagesPtr = dataPtr-&gt;getInSysMessageBuf();</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;        <span class="keywordtype">bool</span> newMessageFlag = TIGLCommunicationExistMessages();</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;<span class="preprocessor">#if DEBUG_MPI</span></div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;        <span class="keywordflow">if</span> (newMessageFlag == <span class="keyword">false</span>) {</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;            cout &lt;&lt; <span class="stringliteral">&quot;           &quot;</span> &lt;&lt; rank &lt;&lt; <span class="stringliteral">&quot; did NOT get any messages&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;        }</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;        <span class="keywordtype">int</span> numMessages = 0;</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;<span class="comment">//      OMP(&quot;omp parallel&quot;)</span></div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;        <span class="keywordflow">while</span> (newMessageFlag == <span class="keyword">true</span>)</div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;        {</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;            messageBuf.clear();</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;            int32 messageSize;</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;            <span class="keywordtype">int</span> tag;</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;<span class="comment">//          OMP(&quot;omp critical(READ_MESSAGE)&quot;)</span></div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;            {</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;                 tag= TIGLCommunicationRecvMPICommand(rxBuf, &amp;messageSize);</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;            }</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;            <span class="keywordflow">if</span>(messageSize == 0)</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;            {</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;                newMessageFlag = TIGLCommunicationExistMessages();</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;                <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;            }</div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;            <span class="comment">// Note: SystemMessage NOT tested yet</span></div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;            <span class="keywordflow">switch</span>(tag)</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;            {</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;                <span class="keywordflow">case</span> MPI_SYSTEM_MESSAGE_TAG:</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;                { <span class="comment">// if system message -&gt; special processing</span></div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;                    <span class="comment">/* Unpack system message */</span></div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;                    <span class="comment">/* System messages do not get combined */</span></div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;                    <span class="comment">/* Each MPI call sends one system message at a time */</span></div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;                    <a class="code" href="classSysMessage.html">SYS_MESSAGE_TYPE</a> newSysMessage;</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;                    <span class="comment">/* Convert from bytes to system message */</span></div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;                    newSysMessage.<a class="code" href="classSysMessage.html#a54804da8f905137a39ecb496b4746bb8">unpack</a>(rxBuf, messageSize);<span class="comment">//newSysMessage.fromBytes(rxBuf, count);</span></div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;                    <span class="comment">/* Push onto buffer to be processed */</span></div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;                    inSysMessagesPtr-&gt;push_back(newSysMessage);</div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;                    <span class="comment">// Note: Data messages has been tested</span></div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;                    <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;                }</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;                <span class="keywordflow">case</span> MPI_DATA_MESSAGE_TAG:</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;                {</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;                    <span class="comment">// the message is a data message</span></div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;                    bytes2Messages(rxBuf, messageSize, messageBuf);</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;                    <span class="keywordflow">for</span>(MESSAGE_BUF_ITERATOR it = messageBuf.begin(); it != messageBuf.end(); ++it)</div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;                    {</div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;                        ID_TYPE rcvr = it-&gt;getRcvr();</div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;                        uint32 pos;</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;                        dataPtr-&gt;findPos(rcvr, pos);<span class="comment">//INDEX_ITERATOR itTargetPos = verticesPosPtr-&gt;find(rcvr);</span></div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;<span class="preprocessor">    #if defined(DEBUG_MPI)</span></div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;                        <span class="keywordflow">if</span>(rcvr == TEST_RCVR)<span class="comment">//(rank == 2 &amp;&amp; rcvr == TEST_RCVR)</span></div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;                            cout &lt;&lt; <span class="stringliteral">&quot;dev&quot;</span> &lt;&lt; rank &lt;&lt; <span class="stringliteral">&quot;(&quot;</span> &lt;&lt; rcvr &lt;&lt; <span class="stringliteral">&quot;) &lt;- &quot;</span> &lt;&lt; it-&gt;getSender() &lt;&lt; <span class="stringliteral">&quot;: &quot;</span> &lt;&lt; it-&gt; getContent() &lt;&lt; endl;</div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;<span class="preprocessor">    #endif</span></div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;</div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;                        <span class="keywordflow">if</span>(dataPtr-&gt;findPos(rcvr, pos) == <span class="keyword">false</span>) <span class="comment">// the vertex does not exist on the device</span></div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;                        { <span class="comment">// The target does not exist in the current core</span></div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;                            <a class="code" href="classSysMessage.html">SYS_MESSAGE_TYPE</a> errMessage(VERTEX_NOT_EXIST, it-&gt;getSender(), &amp;rcvr);</div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;                            <span class="comment">// adding the system message for the next time</span></div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;                            SYS_MBUF_PTR outSysMessagesPtr = dataPtr-&gt;getOutSysMessageBuf();</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;                            outSysMessagesPtr-&gt;push_back(errMessage);</div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;                            <span class="comment">// TODO unlock buffer after writing</span></div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;                            <span class="keywordflow">continue</span>;</div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;                        }</div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;                        <span class="comment">// the rcvr exist at position &quot;pos&quot;</span></div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;                        <span class="comment">// Route to the input message buffer of the following time</span></div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;<span class="preprocessor">    #if defined(_MPI)</span></div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;                        dataPtr-&gt;setExtFlag(pos); <span class="comment">// setting the flag</span></div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;<span class="preprocessor">    #endif</span></div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;</div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;                        <span class="comment">// pushing the message to the appropriate buffer</span></div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;                        dataPtr-&gt;pushDataMessage(*it, pos, (*timeCountSS)%2, omp_get_thread_num());</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;                    }</div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;                    <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;                }</div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;                <span class="keywordflow">case</span> MPI_MUTATION_MESSAGE_TAG:</div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;                {</div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;                    cout &lt;&lt; <span class="stringliteral">&quot;!!!! warning: mutation message processing is not implemented yet !&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;                    <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;                }</div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;                <span class="keywordflow">default</span>:</div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;                {</div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;                    cout &lt;&lt; <span class="stringliteral">&quot;!!!! warning: unknown message tag !&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;                    <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;                }</div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;        }</div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;            <span class="comment">/* Check if there&#39;s any messages sent to me */</span></div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;            newMessageFlag = TIGLCommunicationExistMessages();</div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;            numMessages++;</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;        }</div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;    }</div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;</div>
<div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;</div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;</div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00366"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#aee3cb003701ef5b21185d3669934f277">  366</a></span>&#160;<span class="comment"></span>    <span class="keywordtype">int</span> <a class="code" href="classPregelCommunicator.html#aee3cb003701ef5b21185d3669934f277">TIGLCommunicationRecvMPICommand</a>(byte * rxBuf, uint32 bufSize, int32 src)</div>
<div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;    {</div>
<div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;<span class="preprocessor">#if defined(_MPI)</span></div>
<div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;        MPI_Status stat;</div>
<div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;        MPI_Recv(rxBuf, bufSize, MPI_CHAR, src, MPI_ANY_TAG, MPI_COMM_WORLD, &amp;stat);</div>
<div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;        <span class="keywordflow">return</span> stat.MPI_TAG;</div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;<span class="preprocessor">#else</span></div>
<div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;        <span class="keywordflow">return</span> 0;</div>
<div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;    }</div>
<div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00383"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#ab775dfabdb5064db6afa65091a538228">  383</a></span>&#160;<span class="comment"></span>    <span class="keywordtype">int</span> <a class="code" href="classPregelCommunicator.html#ab775dfabdb5064db6afa65091a538228">TIGLCommunicationRecvMPICommand</a>(byte * rxBuf, uint32 bufSize, int32 src, <span class="keywordtype">int</span> tag)</div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;    {</div>
<div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;<span class="preprocessor">#if defined(_MPI)</span></div>
<div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;        MPI_Status stat;</div>
<div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;        MPI_Recv(rxBuf, bufSize, MPI_CHAR, src, tag, MPI_COMM_WORLD, &amp;stat);</div>
<div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;        <span class="keywordflow">return</span> stat.MPI_TAG;</div>
<div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;<span class="preprocessor">#else</span></div>
<div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;        <span class="keywordflow">return</span> 0;</div>
<div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;    }</div>
<div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;</div>
<div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00399"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#acea08876e4c156436aaf1ba631c74e24">  399</a></span>&#160;<span class="comment"></span>    <span class="keywordtype">int</span> <a class="code" href="classPregelCommunicator.html#acea08876e4c156436aaf1ba631c74e24">TIGLCommunicationRecvMPICommand</a>(byte * rxBuf, int32 * numMessageBytes)</div>
<div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;    {</div>
<div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;<span class="preprocessor">#if defined(_MPI)</span></div>
<div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;        MPI_Status status;</div>
<div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;        MPI_Recv(rxBuf, MAX_MESSAGE_SIZE, MPI_CHAR, MPI_ANY_SOURCE, MPI_ANY_TAG, </div>
<div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;                MPI_COMM_WORLD, &amp;status);</div>
<div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;        <span class="comment">//fromDevId = status.MPI_SOURCE;</span></div>
<div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;        MPI_Get_count(&amp;status, MPI_CHAR, numMessageBytes);</div>
<div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;        <span class="keywordflow">return</span> status.MPI_TAG;</div>
<div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;<span class="preprocessor">#else</span></div>
<div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;        <span class="keywordflow">return</span> 0;</div>
<div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;    }</div>
<div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;</div>
<div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00418"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#adb7a1e64e6f0734f338b8452c964c54c">  418</a></span>&#160;    uint32 <a class="code" href="classPregelCommunicator.html#adb7a1e64e6f0734f338b8452c964c54c">TIGLCommunicationFindDevice</a>(uint32 vtxID)</div>
<div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;    {</div>
<div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;        <span class="keywordflow">return</span> vtxID/(this-&gt;totalNumVertices/this-&gt;numDevices);<span class="comment">//this-&gt;dataPtr-&gt;getOwner(vtxID);</span></div>
<div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;    }</div>
<div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;</div>
<div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00428"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#af0ae3411941092ce8b8c450db50441b1">  428</a></span>&#160;<span class="comment"></span>    <span class="keywordtype">void</span> <a class="code" href="classPregelCommunicator.html#af0ae3411941092ce8b8c450db50441b1">bytes2Messages</a>(byte* rxBuf, uint32 messageSize, MESSAGE_BUF_TYPE &amp;messageBuf)</div>
<div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;    {</div>
<div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;        <span class="comment">//byte *currMsg = rxBuf;</span></div>
<div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;        uint32 numBytes = 0;</div>
<div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;        uint32 totalBytes = 0;</div>
<div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;</div>
<div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;        <span class="keywordflow">do</span></div>
<div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;        {</div>
<div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;            MESSAGE_TYPE newMessage;</div>
<div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;            <span class="comment">//currMsg = newMessage.fromBytes(currMsg, &amp;messageSize);</span></div>
<div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;            numBytes = newMessage.unpack(rxBuf+totalBytes);</div>
<div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;            totalBytes += numBytes;</div>
<div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;            <span class="keywordflow">if</span>(numBytes)</div>
<div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;                messageBuf.push_back(newMessage);</div>
<div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;            <span class="keywordflow">else</span></div>
<div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;                <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;        } <span class="keywordflow">while</span> (totalBytes &lt; messageSize);</div>
<div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;    }</div>
<div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;</div>
<div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00452"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#a4ed0400c51a92b59ffa301963d29d28e">  452</a></span>&#160;<span class="comment"></span>    uint32 <a class="code" href="classPregelCommunicator.html#a4ed0400c51a92b59ffa301963d29d28e">messages2Bytes</a>(MESSAGE_BUF_TYPE * messagePtr, byte * outBuf)</div>
<div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;    {</div>
<div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;        uint32 numBytes = 0;</div>
<div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160;</div>
<div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;        <span class="keywordflow">for</span> (MESSAGE_BUF_ITERATOR it = messagePtr-&gt;begin(); it != messagePtr-&gt;end(); ++it)</div>
<div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;        {</div>
<div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;            <span class="comment">// Convert individual data message</span></div>
<div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160;            numBytes += it-&gt;pack(outBuf + numBytes);</div>
<div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;<span class="comment">//          if (numBytes &gt; MAX_MESSAGE_SIZE){</span></div>
<div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;<span class="comment">//              cout &lt;&lt; dataPtr-&gt;getDeviceId() &lt;&lt; &quot; ERROR: message2Bytes() outBuf overflow&quot; &lt;&lt; endl;</span></div>
<div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;<span class="comment">//              exit(-1);</span></div>
<div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;<span class="comment">//          }</span></div>
<div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;        }</div>
<div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;</div>
<div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;        <span class="keywordflow">return</span> numBytes;</div>
<div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;    }</div>
<div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;</div>
<div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00471"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#a8ab6840262f880fffd8f6645fff27f7c">  471</a></span>&#160;<span class="comment"></span>    <span class="keywordtype">int</span> <a class="code" href="classPregelCommunicator.html#a8ab6840262f880fffd8f6645fff27f7c">getRank</a>(){<span class="keywordflow">return</span> rank;}</div>
<div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;</div>
<div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00476"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#aae5db25c2cbca8041db476be5c0c66b0">  476</a></span>&#160;<span class="comment"></span>    <span class="keywordtype">bool</span> <a class="code" href="classPregelCommunicator.html#aae5db25c2cbca8041db476be5c0c66b0">TIGLCommunicationExistMessages</a>()</div>
<div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;    {</div>
<div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;<span class="preprocessor">#if defined(_MPI)</span></div>
<div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;        MPI_Status stat;</div>
<div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;        <span class="keywordtype">int</span> gotMsg = 0;</div>
<div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;        MPI_Iprobe(MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, &amp;gotMsg, &amp;stat);</div>
<div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;        <span class="keywordflow">return</span>  gotMsg? <span class="keyword">true</span>:<span class="keyword">false</span>;</div>
<div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160;<span class="preprocessor">#else</span></div>
<div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;    }</div>
<div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00491"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#a5df944d875839d0008ea80dff2b19451">  491</a></span>&#160;<span class="comment"></span>    <span class="keywordtype">bool</span> <a class="code" href="classPregelCommunicator.html#a5df944d875839d0008ea80dff2b19451">TIGLCommunicationExistMessagesFromDev</a>(uint32 dev)</div>
<div class="line"><a name="l00492"></a><span class="lineno">  492</span>&#160;    {</div>
<div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;<span class="preprocessor">#if defined(_MPI)</span></div>
<div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;        MPI_Status stat;</div>
<div class="line"><a name="l00495"></a><span class="lineno">  495</span>&#160;        <span class="keywordtype">int</span> gotMsg = 0;</div>
<div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160;        MPI_Iprobe(dev, MPI_ANY_TAG, MPI_COMM_WORLD, &amp;gotMsg, &amp;stat);</div>
<div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;        <span class="keywordflow">return</span>  gotMsg? <span class="keyword">true</span>:<span class="keyword">false</span>;</div>
<div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;<span class="preprocessor">#else</span></div>
<div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00500"></a><span class="lineno">  500</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00501"></a><span class="lineno">  501</span>&#160;    }</div>
<div class="line"><a name="l00502"></a><span class="lineno">  502</span>&#160;    <span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00506"></a><span class="lineno"><a class="line" href="classPregelCommunicator.html#a064c422d0aa2b1bc478cf420c4851656">  506</a></span>&#160;<span class="comment"></span>    <span class="keywordtype">bool</span> <a class="code" href="classPregelCommunicator.html#a064c422d0aa2b1bc478cf420c4851656">TIGLCommunicationExistMessagesWithTag</a>(<span class="keywordtype">int</span> tag)</div>
<div class="line"><a name="l00507"></a><span class="lineno">  507</span>&#160;    {</div>
<div class="line"><a name="l00508"></a><span class="lineno">  508</span>&#160;<span class="preprocessor">#if defined(_MPI)</span></div>
<div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160;        MPI_Status stat;</div>
<div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;        <span class="keywordtype">int</span> gotMsg = 0;</div>
<div class="line"><a name="l00511"></a><span class="lineno">  511</span>&#160;        MPI_Iprobe(MPI_ANY_SOURCE, tag, MPI_COMM_WORLD, &amp;gotMsg, &amp;stat);</div>
<div class="line"><a name="l00512"></a><span class="lineno">  512</span>&#160;        <span class="keywordflow">return</span>  gotMsg? <span class="keyword">true</span>:<span class="keyword">false</span>;</div>
<div class="line"><a name="l00513"></a><span class="lineno">  513</span>&#160;<span class="preprocessor">#else</span></div>
<div class="line"><a name="l00514"></a><span class="lineno">  514</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00515"></a><span class="lineno">  515</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00516"></a><span class="lineno">  516</span>&#160;    }</div>
<div class="line"><a name="l00517"></a><span class="lineno">  517</span>&#160;};</div>
<div class="line"><a name="l00518"></a><span class="lineno">  518</span>&#160;</div>
<div class="line"><a name="l00519"></a><span class="lineno">  519</span>&#160;<span class="comment">//===================================================================================================================================</span></div>
<div class="line"><a name="l00520"></a><span class="lineno">  520</span>&#160;</div>
<div class="line"><a name="l00521"></a><span class="lineno">  521</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* PREGELLOCALCOMMUNICATOR_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classPregelCommunicator_html_aa93cebf937b0f2bea1873a6aa9f9f132"><div class="ttname"><a href="classPregelCommunicator.html#aa93cebf937b0f2bea1873a6aa9f9f132">PregelCommunicator::TIGLCommunicationSendMPICommand</a></div><div class="ttdeci">void TIGLCommunicationSendMPICommand(byte *txBuf, uint32 bufSize, int32 dst)</div><div class="ttdoc">overloaded: sending a single message to a particular destination </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:226</div></div>
<div class="ttc" id="classPregelCommunicator_html_af0ae3411941092ce8b8c450db50441b1"><div class="ttname"><a href="classPregelCommunicator.html#af0ae3411941092ce8b8c450db50441b1">PregelCommunicator::bytes2Messages</a></div><div class="ttdeci">void bytes2Messages(byte *rxBuf, uint32 messageSize, MESSAGE_BUF_TYPE &amp;messageBuf)</div><div class="ttdoc">Convert a sequence of bytes to messages (can be one or more than one messages) </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:428</div></div>
<div class="ttc" id="classPregelCommunicator_html_acf608880f1a6eec80af5fe638422d94b"><div class="ttname"><a href="classPregelCommunicator.html#acf608880f1a6eec80af5fe638422d94b">PregelCommunicator::sendAllMessages</a></div><div class="ttdeci">void sendAllMessages(map&lt; ID_TYPE, MESSAGE_BUF_TYPE &gt; *messagePtr)</div><div class="ttdoc">sending all system and data messages. This is a blocking function </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:145</div></div>
<div class="ttc" id="classSysMessage_html_a54804da8f905137a39ecb496b4746bb8"><div class="ttname"><a href="classSysMessage.html#a54804da8f905137a39ecb496b4746bb8">TIGLCommunicationSysMessage::unpack</a></div><div class="ttdeci">void unpack(byte *buf, uint32 numBytes)</div><div class="ttdoc">unpacking a system message to the object fields </div><div class="ttdef"><b>Definition:</b> tiglCommunicationSysMessage.hpp:151</div></div>
<div class="ttc" id="classPregelCommunicator_html_a4ed0400c51a92b59ffa301963d29d28e"><div class="ttname"><a href="classPregelCommunicator.html#a4ed0400c51a92b59ffa301963d29d28e">PregelCommunicator::messages2Bytes</a></div><div class="ttdeci">uint32 messages2Bytes(MESSAGE_BUF_TYPE *messagePtr, byte *outBuf)</div><div class="ttdoc">Convert a group of data messages to a sequence of bytes to be sent. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:452</div></div>
<div class="ttc" id="classPregelCommunicator_html_a0c1fec23444ddd131dd6eac0626ada3b"><div class="ttname"><a href="classPregelCommunicator.html#a0c1fec23444ddd131dd6eac0626ada3b">PregelCommunicator::init</a></div><div class="ttdeci">void init(DATA_CONTAINER_TYPE *dPtr, uint32 devices=1, uint32 devRank=0)</div><div class="ttdoc">initializes the communicator object </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:122</div></div>
<div class="ttc" id="classPregelCommunicator_html_a1d2f789f3c492ab86520f2f9f05e4f7d"><div class="ttname"><a href="classPregelCommunicator.html#a1d2f789f3c492ab86520f2f9f05e4f7d">PregelCommunicator::numDevices</a></div><div class="ttdeci">uint32 numDevices</div><div class="ttdoc">total number of devices </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:87</div></div>
<div class="ttc" id="classPregelCommunicator_html_a0b2ec835552c9c7c11914f42f928af0b"><div class="ttname"><a href="classPregelCommunicator.html#a0b2ec835552c9c7c11914f42f928af0b">PregelCommunicator::sendDataMessages</a></div><div class="ttdeci">void sendDataMessages(map&lt; ID_TYPE, MESSAGE_BUF_TYPE &gt; *messagePtr)</div><div class="ttdoc">core function for sending all MPI data messages </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:184</div></div>
<div class="ttc" id="classPregelCommunicator_html_a87e606cfb6aa33ece2ab1ac00d41be24"><div class="ttname"><a href="classPregelCommunicator.html#a87e606cfb6aa33ece2ab1ac00d41be24">PregelCommunicator::TIGLCommunicationSendMPICommand</a></div><div class="ttdeci">void TIGLCommunicationSendMPICommand(byte *txBuf, uint32 bufSize, int32 dst, int tag)</div><div class="ttdoc">overloaded: sending a single message to a particular destination with a given tag ...</div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:242</div></div>
<div class="ttc" id="classPregelCommunicator_html_acea08876e4c156436aaf1ba631c74e24"><div class="ttname"><a href="classPregelCommunicator.html#acea08876e4c156436aaf1ba631c74e24">PregelCommunicator::TIGLCommunicationRecvMPICommand</a></div><div class="ttdeci">int TIGLCommunicationRecvMPICommand(byte *rxBuf, int32 *numMessageBytes)</div><div class="ttdoc">receiving a message with any tag from any source </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:399</div></div>
<div class="ttc" id="classPregelCommunicator_html_a8ab6840262f880fffd8f6645fff27f7c"><div class="ttname"><a href="classPregelCommunicator.html#a8ab6840262f880fffd8f6645fff27f7c">PregelCommunicator::getRank</a></div><div class="ttdeci">int getRank()</div><div class="ttdoc">returns the rank of the device </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:471</div></div>
<div class="ttc" id="classPregelCommunicator_html_a65d86ed247f64d459e354692048afaa0"><div class="ttname"><a href="classPregelCommunicator.html#a65d86ed247f64d459e354692048afaa0">PregelCommunicator::instRecvMessages</a></div><div class="ttdeci">bool instRecvMessages()</div><div class="ttdoc">core function for receiving all MPI messages (This is a blocking function) It checks for input MPI me...</div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:255</div></div>
<div class="ttc" id="classPregelCommunicator_html_a9342c483ed8bc1478e5991cac92304a0"><div class="ttname"><a href="classPregelCommunicator.html#a9342c483ed8bc1478e5991cac92304a0">PregelCommunicator::totalNumVertices</a></div><div class="ttdeci">uint64 totalNumVertices</div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:90</div></div>
<div class="ttc" id="classPregelCommunicator_html_ac9fa67b645c820c2f37cea3dcd36fbd7"><div class="ttname"><a href="classPregelCommunicator.html#ac9fa67b645c820c2f37cea3dcd36fbd7">PregelCommunicator::PregelCommunicator</a></div><div class="ttdeci">PregelCommunicator(DATA_CONTAINER_TYPE *dataPtr, uint32 devices, int rank=0)</div><div class="ttdoc">@ brief constructor that has the data pointer and </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:73</div></div>
<div class="ttc" id="classPregelCommunicator_html_ab775dfabdb5064db6afa65091a538228"><div class="ttname"><a href="classPregelCommunicator.html#ab775dfabdb5064db6afa65091a538228">PregelCommunicator::TIGLCommunicationRecvMPICommand</a></div><div class="ttdeci">int TIGLCommunicationRecvMPICommand(byte *rxBuf, uint32 bufSize, int32 src, int tag)</div><div class="ttdoc">receiving a message from a particular src with a given tag </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:383</div></div>
<div class="ttc" id="classPregelCommunicator_html_aae5db25c2cbca8041db476be5c0c66b0"><div class="ttname"><a href="classPregelCommunicator.html#aae5db25c2cbca8041db476be5c0c66b0">PregelCommunicator::TIGLCommunicationExistMessages</a></div><div class="ttdeci">bool TIGLCommunicationExistMessages()</div><div class="ttdoc">check if there exist messages from any source with any tag </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:476</div></div>
<div class="ttc" id="classPregelCommunicator_html"><div class="ttname"><a href="classPregelCommunicator.html">PregelCommunicator</a></div><div class="ttdoc">core communicator class definition It handles all the MPI communication between devices (including bo...</div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:52</div></div>
<div class="ttc" id="tiglCommunicationSysMessage_8hpp_html"><div class="ttname"><a href="tiglCommunicationSysMessage_8hpp.html">tiglCommunicationSysMessage.hpp</a></div><div class="ttdoc">contains core System Massage container class for Pregel </div></div>
<div class="ttc" id="tiglContainersPregelDataContainer_8hpp_html"><div class="ttname"><a href="tiglContainersPregelDataContainer_8hpp.html">tiglContainersPregelDataContainer.hpp</a></div><div class="ttdoc">contains implementation of both single-core and openMP pregel data container class ...</div></div>
<div class="ttc" id="classPregelCommunicator_html_adb7a1e64e6f0734f338b8452c964c54c"><div class="ttname"><a href="classPregelCommunicator.html#adb7a1e64e6f0734f338b8452c964c54c">PregelCommunicator::TIGLCommunicationFindDevice</a></div><div class="ttdeci">uint32 TIGLCommunicationFindDevice(uint32 vtxID)</div><div class="ttdoc">finds the device of a given vertex </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:418</div></div>
<div class="ttc" id="classPregelCommunicator_html_aee3cb003701ef5b21185d3669934f277"><div class="ttname"><a href="classPregelCommunicator.html#aee3cb003701ef5b21185d3669934f277">PregelCommunicator::TIGLCommunicationRecvMPICommand</a></div><div class="ttdeci">int TIGLCommunicationRecvMPICommand(byte *rxBuf, uint32 bufSize, int32 src)</div><div class="ttdoc">receiving a message from a particular src with any tag </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:366</div></div>
<div class="ttc" id="classPregelCommunicator_html_ad2369b8d191a328714ce2c0c9372e1b6"><div class="ttname"><a href="classPregelCommunicator.html#ad2369b8d191a328714ce2c0c9372e1b6">PregelCommunicator::timeCountSS</a></div><div class="ttdeci">uint32 * timeCountSS</div><div class="ttdoc">pointer to the ss counter </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:93</div></div>
<div class="ttc" id="classPregelCommunicator_html_a8e99d93e817dc4cc4a7d97d34a941d41"><div class="ttname"><a href="classPregelCommunicator.html#a8e99d93e817dc4cc4a7d97d34a941d41">PregelCommunicator::sendSysMessages</a></div><div class="ttdeci">void sendSysMessages()</div><div class="ttdoc">sending all system messages. This is a blocking function </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:153</div></div>
<div class="ttc" id="classPregelCommunicator_html_a064c422d0aa2b1bc478cf420c4851656"><div class="ttname"><a href="classPregelCommunicator.html#a064c422d0aa2b1bc478cf420c4851656">PregelCommunicator::TIGLCommunicationExistMessagesWithTag</a></div><div class="ttdeci">bool TIGLCommunicationExistMessagesWithTag(int tag)</div><div class="ttdoc">check if there exist messages with a given tag from any source </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:506</div></div>
<div class="ttc" id="classPregelCommunicator_html_a886da2e5d226022133297f6461033f2a"><div class="ttname"><a href="classPregelCommunicator.html#a886da2e5d226022133297f6461033f2a">PregelCommunicator::rank</a></div><div class="ttdeci">uint32 rank</div><div class="ttdoc">MPI rank of the current device. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:96</div></div>
<div class="ttc" id="classPregelCommunicator_html_a0b8291a5b8a01bed346f27d6eb2b519e"><div class="ttname"><a href="classPregelCommunicator.html#a0b8291a5b8a01bed346f27d6eb2b519e">PregelCommunicator::setNumVertices</a></div><div class="ttdeci">void setNumVertices(uint64 numVertices)</div><div class="ttdoc">passes the total number of vertices in the graph (used in finding the device for each vertex) ...</div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:134</div></div>
<div class="ttc" id="classPregelCommunicator_html_ad0836c0a6713b5084626c053b2609721"><div class="ttname"><a href="classPregelCommunicator.html#ad0836c0a6713b5084626c053b2609721">PregelCommunicator::dataPtr</a></div><div class="ttdeci">DATA_CONTAINER_TYPE * dataPtr</div><div class="ttdoc">pointer to PregelDataContainer object that contains all message buffers </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:83</div></div>
<div class="ttc" id="classPregelCommunicator_html_aac3d9db0bfd173f6c9d24d06d8ff0a56"><div class="ttname"><a href="classPregelCommunicator.html#aac3d9db0bfd173f6c9d24d06d8ff0a56">PregelCommunicator::isMultipleDevices</a></div><div class="ttdeci">bool isMultipleDevices()</div><div class="ttdoc">returns true if multiple devices are used, otherwise returns false </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:140</div></div>
<div class="ttc" id="classPregelCommunicator_html_a5df944d875839d0008ea80dff2b19451"><div class="ttname"><a href="classPregelCommunicator.html#a5df944d875839d0008ea80dff2b19451">PregelCommunicator::TIGLCommunicationExistMessagesFromDev</a></div><div class="ttdeci">bool TIGLCommunicationExistMessagesFromDev(uint32 dev)</div><div class="ttdoc">check if there exist messages with any tag from a given source device </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:491</div></div>
<div class="ttc" id="classSysMessage_html"><div class="ttname"><a href="classSysMessage.html">TIGLCommunicationSysMessage</a></div><div class="ttdoc">core system message class definition It handles all the system message fields and processing ...</div><div class="ttdef"><b>Definition:</b> tiglCommunicationSysMessage.hpp:61</div></div>
<div class="ttc" id="classPregelCommunicator_html_ac0c5a6de5c5f1802a46962a2ea7294fc"><div class="ttname"><a href="classPregelCommunicator.html#ac0c5a6de5c5f1802a46962a2ea7294fc">PregelCommunicator::reset</a></div><div class="ttdeci">void reset()</div><div class="ttdoc">reset procedure </div><div class="ttdef"><b>Definition:</b> tiglCommunicationPregelCommunicator.hpp:102</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Oct 14 2014 14:29:26 for TIGL by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
